#this script captures faces and then creates a dataset to dataSet/ folder
#Three steps to recognise face
    #1: create dataset -> dataset creator
    #2: train the recogniser -> trainner
    #3: face detector -> detector   <- THIS SCRIPT DOES THIS 1st STEP
#Tutorial: https://www.youtube.com/watch?v=6gWS2CdtZrs

import cv2
import numpy as np
import sqlite3
import winsound

faceDetect = cv2.CascadeClassifier('haarcascade_frontalface_default.xml');

def getProfile(id):
    conn = sqlite3.connect("FaceBase.db")
    cmd = "SELECT * FROM People WHERE ID="+str(id)
    cursor = conn.execute(cmd)
    profile = None
    for row in cursor:
        profile = row
    conn.close()
    return profile


#change VideoCapture(*number*) to change camera input
cam = cv2.VideoCapture(1);
recognizer = cv2.face.createLBPHFaceRecognizer()
#load training data
recognizer.load('recognizer/trainingData.yml')
id = 0
# font = cv2.cv.InitFont(cv2.cv.CV_FONT_HERSHEY_COMPLEX_SMALL,5,1,0,4)
font = cv2.FONT_HERSHEY_DUPLEX

while(True):
    ret,img = cam.read();
    #Convert image to grayscale
    gray = cv2.cvtColor(img,cv2.COLOR_BGR2GRAY)
    faces = faceDetect.detectMultiScale(gray,1.3,5);

    #loop faces detected
    for (x,y,w,h) in faces:
        #draw rectangle
        cv2.rectangle( img,(x,y,),(x+w,y+h),(0,255,0),2 )
        id,conf = recognizer.predict(gray[y:y+h,x:x+w])
        #zero is 100 percent match, about 60 is uncertain
        if (conf < 70):
            profile = getProfile(id)

            if(profile!=None):

                #if the person is SELF-EXCLUDED
                if (str(profile[3])=="True" or str(profile[3])=="true" ):
                    detectColor = (0,0,255)
                    cv2.rectangle( img,(x,y,),(x+w,y+h),(0,0,255),2 )
                    # winsound.PlaySound('beep-07.wav',winsound.SND_FILENAME)
                    cv2.putText(img,"SELF-EXCLUDED",(x,y+h+90),font, 1,detectColor,1)  #Excluded
                else:
                    detectColor = (0,255,0)

                #cv2.putText(img, text, org, fontFace, fontScale, color[, thickness[, lineType[, bottomLeftOrigin]]])
                cv2.putText(img,"Name: "+str(profile[1]),(x,y+h+30),font, 1,detectColor,1)  #Name
                cv2.putText(img,"Gender: "+str(profile[2]),(x,y+h+60),font, 1,detectColor,1)  #Gender
                # cv2.putText(img,"OK",(x,y+h+90),font, 1,detectColor,1)  #Gender

        else:
            cv2.putText(img,"Unknown",(x,y+h+30),font, 1,(0,255,0),1)
    #cv2.namedWindow(winname[, flags])

    cv2.namedWindow("Face", cv2.WND_PROP_FULLSCREEN)
    cv2.setWindowProperty("Face", cv2.WND_PROP_FULLSCREEN, cv2.WINDOW_FULLSCREEN)
    cv2.imshow("Face",img);
    #after 20 photos, break
    if(cv2.waitKey(1)==ord('q')):
        break;
cam.release()
cv2.destroyAllWindows()
